(*
  ************************** SetParPort.dll ************************************
  V0.2 - (c) Martin Frei 2008


  Schalten des (parallel)-Ports unter Win98/XP/2k

  Es wird die DLL inpout32.dll vorausgesetzt (in aktuellem oder in
  Windows-System-Verzeichnis)
  -> http://logix4u.net/Legacy_Ports/Parallel_Port/Inpout32.dll_for_Windows_98/2000/NT/XP.html

  Bentigte Bibliotheken:
  PHP4Delphi
  -> http://users.telenet.be/ws36637/php4delphi.html#download


  Funktionen:

  - parport_setdatabit(BaseAdress:integer; Bit:string; On:boolean);

    BaseAdress: Basisadresse des Parallel-Ports (z.B. LPT1:0x378, LPT2:0x278)
           Bit: '0'..'7' fr die Datenleitungen 0..7, '9' fr alle Datenleitungen
            On: True/False


  - parport_setctrlbit(BaseAdress:integer; Bit:string; On:boolean);

    BaseAdress: Basisadresse des Parallel-Ports (z.B. LPT1:0x378, LPT2:0x278)
           Bit: 'S'=Strobe, 'L'=LineFeed, 'I'=Init, 'C'=Select, 'A'=alle
            On: True/False
*)

unit main;

interface

uses
   zendTypes,
   zendAPI,
   phpTypes,
   phpAPI,
   phpFunctions,
   PHPModules;

type

  TParPortFunctions = class(TPHPExtension)
    procedure ParPortFunctionsFunctions1Execute(Sender: TObject;
      Parameters: TFunctionParams; var ReturnValue: Variant;
      ThisPtr: pzval; TSRMLS_DC: Pointer);
    procedure ParPortFunctionsFunctions0Execute(Sender: TObject;
      Parameters: TFunctionParams; var ReturnValue: Variant;
      ThisPtr: pzval; TSRMLS_DC: Pointer);
  private
    { Private declarations }
    procedure Switch(Adr:integer; Kind:string; SetOn:boolean);
  public
    { Public declarations }
  end;


procedure Out32(wAddr:word;bOut:byte); stdcall; external 'inpout32.dll'
function Inp32(wAddr:word):integer; stdcall; external 'inpout32.dll'

var
  ParPortFunctions: TParPortFunctions;

//------------------------------------------------------------------------------
implementation

{$R *.DFM}

//--------------------------------------------------------------------------------
procedure TParPortFunctions.Switch(Adr:integer; Kind:string; SetOn:boolean);
var sta,msk:byte;
begin
  if Kind='' then Kind:='0';

  case kind[1] of
    '0'..'7':msk:=$01 shl(byte(kind[1]) and $0f);
    '9':msk:=$ff;
    'S':msk:=$01;
    'L':msk:=$02;
    'I':msk:=$04;
    'C':msk:=$08;
    'A':msk:=$ff;
    'x':msk:=$f0;
    else msk:=$00;
  end;

  // folgende Signale liegen invertiert an
  if (Kind[1] in['S','L','C']) then setOn:=not setOn;

  sta:=Inp32(Adr);
  if setOn then sta:=sta or msk
  else sta:=sta and (msk xor $ff);
  Out32(Adr,sta);
end;

//------------------------------------------------------------------------------
procedure TParPortFunctions.ParPortFunctionsFunctions0Execute(
  Sender: TObject; Parameters: TFunctionParams; var ReturnValue: Variant;
  ThisPtr: pzval; TSRMLS_DC: Pointer);
begin
  if Parameters.Count = 3 then
  begin
    // immer zuerst unused Control-Bits auf 0 stellen (falls Port in ECP-Mode)
    Switch(Parameters[0].Value+2, 'x', false);
    // Databit schalten
    Switch(Parameters[0].Value+0, Parameters[1].Value, Parameters[2].Value);
    ReturnValue:='OK';
  end
  else ReturnValue:='Wrong Parameters';
end;

//------------------------------------------------------------------------------
procedure TParPortFunctions.ParPortFunctionsFunctions1Execute(
  Sender: TObject; Parameters: TFunctionParams; var ReturnValue: Variant;
  ThisPtr: pzval; TSRMLS_DC: Pointer);
begin
  if Parameters.Count = 3 then
  begin
    // immer zuerst unused Control-Bits auf 0 stellen (falls Port in ECP-Mode)
    Switch(Parameters[0].Value+2, 'x', false);
    // Controlbit schalten
    Switch(Parameters[0].Value+2, Parameters[1].Value, Parameters[2].Value);
    ReturnValue:='OK';
  end
  else ReturnValue:='Wrong Parameters';
end;

end.
